-- This file is loaded from "HerbCount.toc"

function CountHerbs(itemID)
	local _, itemLink = GetItemInfo(itemID)
	local total = 0

	for bag = 0, NUM_BAG_SLOTS do
		for slot = 1, GetContainerNumSlots(bag) do
			if (GetContainerItemLink(bag, slot) == itemLink) then
				if select(2, GetContainerItemInfo(bag, slot)) then
					total = total + select(2, GetContainerItemInfo(bag, slot))
				end
			end
		end
	end
	return total
end

function initiateHerb(frame, text, id, yposition)
	local herbTexture = CreateFrame("frame", text, frame)
	herbTexture:SetSize(12,12)
	herbTexture:SetPoint("TOPLEFT", 5, yposition)
	local t = herbTexture:CreateTexture(nil,"BACKGROUND")
	t:SetTexture(GetItemIcon(id))
	t:SetAllPoints(herbTexture)
	herbTexture.texture = t
	frame[text] = frame[text] or frame:CreateFontString(nil, "OVERLAY")
	frame[text]:SetFont("FONTS\\FRIZQT__.TTF", 10, "OUTLINE")
	frame[text]:SetPoint("TOPLEFT", 20, yposition-1)
end

local herbs = {
	brindemer = 152511,
	ancoracee = 152510,
	pollendesirene = 152509,
	brisedhiver = 152508,
	machedakunda = 152507,
	mousseetoilee = 152506,
	rivebulbe = 152505,
}

local herbCountFrame = CreateFrame("frame", "herbCountFrame")
herbCountFrame:SetSize(150,113)

herbCountFrame:SetBackdrop({
	bgFile="Interface\\ChatFrame\\ChatFrameBackground",
	edgeFile="Interface\\ChatFrame\\ChatFrameBackground",
	tile=true,
	tileSize=5,
	edgeSize= 2,
})
herbCountFrame:SetBackdropColor(0.1,0.1,0.1,0.8)
herbCountFrame:SetBackdropBorderColor(0.1,0.1,0.1,0.8)
local yposition = -5
for herb, id in pairs(herbs) do
	initiateHerb(herbCountFrame, herb, id, yposition)
	yposition = yposition - 15
end
herbCountFrame:SetFrameStrata("HIGH")
herbCountFrame:SetPoint("CENTER", UIParent)
herbCountFrame:SetMovable(true)
herbCountFrame:EnableMouse(true)
herbCountFrame:RegisterForDrag("LeftButton")
herbCountFrame:SetScript("OnDragStart", herbCountFrame.StartMoving)
herbCountFrame:SetScript("OnDragStop", herbCountFrame.StopMovingOrSizing)
herbCountFrame:SetClampedToScreen(true)

local updateCount = CreateFrame("frame")
updateCount:RegisterEvent("BAG_UPDATE")
updateCount:SetScript("OnEvent", function()
	local herbscount = {
		brindemer = 0,
		ancoracee = 0,
		pollendesirene = 0,
		brisedhiver = 0,
		machedakunda = 0,
		mousseetoilee = 0,
		rivebulbe = 0,
	}

	for herb, id in pairs(herbs) do
		herbscount[herb] = CountHerbs(id)
		local itemName = GetItemInfo(id)
		herbCountFrame[herb]:SetText(itemName .. " : " .. herbscount[herb])
	end
end)

local function HerbCountCommands(msg, editbox)
  if msg == 'hide' then
    herbCountFrame:Hide()
	elseif msg == 'show' then
    herbCountFrame:Show()
	elseif herbCountFrame:IsVisible() then
    herbCountFrame:Hide()
	elseif not herbCountFrame:IsVisible() then
    herbCountFrame:Show()
  end
end

SLASH_HERBCOUNT1 = "/herbcount"

SlashCmdList["HERBCOUNT"] = HerbCountCommands
